# Method: projects.locations.corpora.searchConfigs.create

- [HTTP request](https://docs.cloud.google.com/vision-ai/docs/reference/rest/v1/projects.locations.corpora.searchConfigs/create#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/vision-ai/docs/reference/rest/v1/projects.locations.corpora.searchConfigs/create#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/vision-ai/docs/reference/rest/v1/projects.locations.corpora.searchConfigs/create#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/vision-ai/docs/reference/rest/v1/projects.locations.corpora.searchConfigs/create#body.request_body)
- [Response body](https://docs.cloud.google.com/vision-ai/docs/reference/rest/v1/projects.locations.corpora.searchConfigs/create#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/vision-ai/docs/reference/rest/v1/projects.locations.corpora.searchConfigs/create#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/vision-ai/docs/reference/rest/v1/projects.locations.corpora.searchConfigs/create#body.aspect_1)

Creates a search configuration inside a corpus.

Please follow the rules below to create a valid CreateSearchConfigRequest. --- General Rules --- 1. Request.search_config_id must not be associated with an existing SearchConfig. 2. Request must contain at least one non-empty searchCriteriaProperty or facetProperty. 3. mappedFields must not be empty, and must map to existing UGA keys. 4. All mappedFields must be of the same type. 5. All mappedFields must share the same granularity. 6. All mappedFields must share the same semantic SearchConfig match options. For property-specific rules, please reference the comments for FacetProperty and SearchCriteriaProperty.

### HTTP request

`POST https://visionai.googleapis.com/v1/{parent=projects/*/locations/*/corpora/*}/searchConfigs`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. The parent resource where this search configuration will be created. Format: `projects/{project_number}/locations/{locationId}/corpora/{corpus_id}` |

### Query parameters

| Parameters ||
|---|---|
| `searchConfigId` | `string` Required. ID to use for the new search config. Will become the final component of the SearchConfig's resource name. This value should be up to 63 characters, and valid characters are /\[a-z\]\[0-9\]-_/. The first character must be a letter, the last could be a letter or a number. |

### Request body

The request body contains an instance of `https://docs.cloud.google.com/vision-ai/docs/reference/rest/v1/projects.locations.corpora.searchConfigs#SearchConfig`.

### Response body

If successful, the response body contains a newly created instance of `https://docs.cloud.google.com/vision-ai/docs/reference/rest/v1/projects.locations.corpora.searchConfigs#SearchConfig`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://cloud.google.com/docs/authentication/).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `parent` resource:

- `visionai.searchConfigs.create`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).